forked from fishercoder1534/Leetcode
-
Notifications
You must be signed in to change notification settings - Fork 0
/
_481.java
78 lines (61 loc) · 2.4 KB
/
_481.java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
package com.fishercoder.solutions;
/**
* 481. Magical String
*
* A magical string S consists of only '1' and '2' and obeys the following rules:
The string S is magical because concatenating the number of contiguous occurrences of characters '1' and '2' generates the string S itself.
The first few elements of string S is the following: S = "1221121221221121122……"
If we group the consecutive '1's and '2's in S, it will be:
1 22 11 2 1 22 1 22 11 2 11 22 ......
and the occurrences of '1's or '2's in each group are:
1 2 2 1 1 2 1 2 2 1 2 2 ......
You can see that the occurrence sequence above is the S itself.
Given an integer N as input, return the number of '1's in the first N number in the magical string S.
Note: N will not exceed 100,000.
Example 1:
Input: 6
Output: 3
Explanation: The first 6 elements of magical string S is "12211" and it contains three 1's, so return 3.
*/
public class _481 {
public static class Solution1 {
/**
* credit: https://discuss.leetcode.com/topic/74917/simple-java-solution-using-one-array-and-two-pointers
* Algorithm:
*
* 1. Create an int array a and initialize the first 3 elements with 1, 2, 2.
* 2. Create two pointers head and tail. head points to the number which will be used to generate new numbers.
* tail points to the next empty position to put the new number. Then keep generating new numbers until tail >= n.
* 3. Need to create the array 1 element more than n to avoid overflow because the last round head might points to a number 2.
* 4. A trick to flip number back and forth between 1 and 2: num = num ^ 3
*/
public int magicalString(int n) {
if (n <= 0) {
return 0;
}
if (n <= 3) {
return 1;
}
int[] a = new int[n + 1];
a[0] = 1;
a[1] = 2;
a[2] = 2;
int head = 2;
int tail = 3;
int num = 1;
int result = 1;
while (tail < n) {
for (int i = 0; i < a[head]; i++) {
a[tail] = num;
if (num == 1 && tail < n) {
result++;
}
tail++;
}
num = num ^ 3;
head++;
}
return result;
}
}
}